/*
 * MySQLCDRGenerator.php
 * 
 * Copyright 2012 ShadoWalkeR <archer2006@list.ru>
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * 
 * * Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer.
 * * Redistributions in binary form must reproduce the above
 *   copyright notice, this list of conditions and the following disclaimer
 *   in the documentation and/or other materials provided with the
 *   distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * 
 */
 
<?php
//********************************************************************//
//**************************ОПРЕДЕЛЕНИЯ*ФУНКЦИЙ***********************//
//********************************************************************//

//Логирование ошибок
function SendReportToLog($msg)
{
	global $logfile;
	if ($logfile !== 'NULL')
	{
		$time = date('Y.m.d G:i:s ');
		error_log($time.$msg."\n",3,$logfile);
	}
}

//Вычисляем длительность разговора
function DialogLenght($start_time,$end_time)
{
	$unix_start_time = strtotime($start_time);
	$unix_end_time = strtotime($end_time);
	$dif = $unix_end_time - $unix_start_time;
	return $dif;
}

//Запрашиваем все записи BYE, без отметки о записи CDR
function MySQLGetBYEs($database)
{
    $mq = "SELECT * ".
			"FROM $database.acc ".
			"WHERE `method` = 'BYE' ".
			"AND `cdr_id` = '0'";
    return mysql_query($mq);
}

//Запрашиваем запись INVITE
function MySQLGetINVITE($database,$from_tag,$to_tag,$callid)
{
    $mq = "SELECT * ".
			"FROM $database.acc ".
			"WHERE `method` = 'INVITE' ".
			"AND `from_tag` = '$from_tag' ".
			"AND `to_tag` = '$to_tag' ".
			"AND `callid` = '$callid'";
    $mquery = mysql_query($mq);
    return mysql_fetch_assoc($mquery);
}

//Генерируем запись CDR и записываем её в таблицу cdrs
function GenerateCDR($database,$invite,$lenght)
{
	$created = date('Y.m.d G:i:s');
	$mq = "INSERT INTO $database.cdrs (cdr_id,".
					"src,".
					"dst,".
					"call_start_time,".
					"duration,".
					"sip_call_id,".
					"sip_from_tag,".
					"sip_to_tag,".
					"created) ". 
				"VALUES(NULL,'".
					$invite["src"]."','".
					$invite["dst"]."','".
					$invite["time"]."','".
					$lenght."','".
					$invite["callid"]."','".
					$invite["from_tag"]."','".
					$invite["to_tag"]."','".
					"$created')";
					
	//Логируем наш запрос
	SendReportToLog("INFO: Generated CDR: $mq");
	
	//Выполняем запрос
	mysql_query($mq);
	
	$mq = "SELECT `cdr_id` ". 
			"FROM $database.cdrs ".
			"WHERE `sip_call_id` = '".$invite["callid"]."'";
			
	//Логируем запрос результата:
	SendReportToLog("INFO: Getting cdr_id: $mq");
	
	$mquery = mysql_query($mq);
	
	$result = mysql_fetch_assoc($mquery);
	
	return $result["cdr_id"];
}

//Задаем cdr_id в acc
function SetCDRID($database,$cdrid,$callid)
{
	$mq = "UPDATE $database.acc ".
			"SET `cdr_id` = '$cdrid' ".
			"WHERE `callid` = '$callid' ".
			"AND `cdr_id` = '0'";
	
	mysql_query($mq);
	//Логируем запрос результата:
	SendReportToLog("INFO: Setting cdr_id in acc: $mq");
}

?>
